#ifndef __ydk_std_h__
#define __ydk_std_h__



//#define YDK_STD_DEBUG
#define YDK_STD_ERROR_VERBOSE
//#define YDK_ZLIB


#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif


#include "YDKmenu.h"

void *ydk_malloc(unsigned int size);
void *ydk_calloc(unsigned int num_elt,unsigned int size_elt);
void ydk_free(void *ptr);

void ydk_std_showstat(void);

void ydk_cls(UInt32 col);

#ifdef YDK_ZLIB
#include "zlib.h"
#define STREAM gzFile
#define READ_STREAM(p,l,s) gzread (s,p,l)
#define WRITE_STREAM(p,l,s) gzwrite (s,p,l)
#define OPEN_STREAM(f,m) gzopen (f,m)
#define CLOSE_STREAM(s) gzclose (s)
#define SEEK_STREAM(p,r,s) gzseek(s,p,r)
#endif


#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif